Distribution by Cohort in JavaScript

Using ApexCharts with JavaScript

This Distribution by Cohort example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Eight monthly signup cohorts, ~240 raw onboarding times each. Every panel
// is a real histogram over its own observations, but the trellis derives ONE
// set of bin edges over the union sample and pushes it into every panel, so
// the same bar in every panel means the same interval and the drift of the
// whole distribution (newer cohorts finish faster) reads directly. Overlaid
// translucent histograms stop being readable past about three; eight panels
// with shared edges stay readable.
//
// Deterministic samples so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

// Bell-ish sample: mean minutes drop cohort by cohort, spread tightens.
function onboardingMinutes(seed, mean, spread, n) {
  var rand = mulberry32(seed)
  var out = []
  for (var i = 0; i < n; i++) {
    var v = mean + (rand() + rand() + rand() - 1.5) * spread
    // A slow tail: some users always wander off mid-setup.
    if (rand() < 0.06) v += rand() * 25
    out.push(Math.max(2, Math.round(v * 10) / 10))
  }
  return out
}

var COHORTS = [
  { name: 'Jan', seed: 11, mean: 34, spread: 14 },
  { name: 'Feb', seed: 23, mean: 32, spread: 13 },
  { name: 'Mar', seed: 37, mean: 30, spread: 13 },
  { name: 'Apr', seed: 41, mean: 27, spread: 12 },
  { name: 'May', seed: 53, mean: 25, spread: 11 },
  { name: 'Jun', seed: 67, mean: 22, spread: 10 },
  { name: 'Jul', seed: 79, mean: 20, spread: 9 },
  { name: 'Aug', seed: 97, mean: 18, spread: 8 },
]

var cohortSeries = COHORTS.map(function (c) {
  return {
    name: 'Onboarding time',
    cohort: c.name + ' cohort',
    data: onboardingMinutes(c.seed, c.mean, c.spread, 240),
  }
})

var options = {
  series: cohortSeries,
  chart: {
    id: 'cohortTrellis',
    type: 'histogram',
    height: 560,
    animations: {
      enabled: false,
    },
  },
  trellis: {
    by: 'cohort',
    columns: 4,
    gap: 12,
  },
  colors: ['#0E7490'],
  plotOptions: {
    histogram: {
      bins: 'auto',
    },
  },
  xaxis: {
    tickAmount: 5,
    labels: {
      rotate: 0,
      formatter: function (val) {
        return Math.round(Number(val)) + 'm'
      },
    },
  },
  dataLabels: {
    enabled: false,
  },
  stroke: {
    width: 1,
    colors: ['#fff'],
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Distribution by Cohort in React

Using ApexCharts with React

This Distribution by Cohort example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

import 'apexcharts/features/trellis'

// Eight monthly signup cohorts, ~240 raw onboarding times each. Every panel
// is a real histogram over its own observations, but the trellis derives ONE
// set of bin edges over the union sample and pushes it into every panel, so
// the same bar in every panel means the same interval and the drift of the
// whole distribution (newer cohorts finish faster) reads directly. Overlaid
// translucent histograms stop being readable past about three; eight panels
// with shared edges stay readable.
//
// Deterministic samples so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

// Bell-ish sample: mean minutes drop cohort by cohort, spread tightens.
function onboardingMinutes(seed, mean, spread, n) {
  var rand = mulberry32(seed)
  var out = []
  for (var i = 0; i < n; i++) {
    var v = mean + (rand() + rand() + rand() - 1.5) * spread
    // A slow tail: some users always wander off mid-setup.
    if (rand() < 0.06) v += rand() * 25
    out.push(Math.max(2, Math.round(v * 10) / 10))
  }
  return out
}

var COHORTS = [
  { name: 'Jan', seed: 11, mean: 34, spread: 14 },
  { name: 'Feb', seed: 23, mean: 32, spread: 13 },
  { name: 'Mar', seed: 37, mean: 30, spread: 13 },
  { name: 'Apr', seed: 41, mean: 27, spread: 12 },
  { name: 'May', seed: 53, mean: 25, spread: 11 },
  { name: 'Jun', seed: 67, mean: 22, spread: 10 },
  { name: 'Jul', seed: 79, mean: 20, spread: 9 },
  { name: 'Aug', seed: 97, mean: 18, spread: 8 },
]

var cohortSeries = COHORTS.map(function (c) {
  return {
    name: 'Onboarding time',
    cohort: c.name + ' cohort',
    data: onboardingMinutes(c.seed, c.mean, c.spread, 240),
  }
})

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: cohortSeries,
    options: {
      chart: {
        id: 'cohortTrellis',
        type: 'histogram',
        height: 560,
        animations: {
          enabled: false,
        },
      },
      trellis: {
        by: 'cohort',
        columns: 4,
        gap: 12,
      },
      colors: ['#0E7490'],
      plotOptions: {
        histogram: {
          bins: 'auto',
        },
      },
      xaxis: {
        tickAmount: 5,
        labels: {
          rotate: 0,
          formatter: function (val) {
            return Math.round(Number(val)) + 'm'
          },
        },
      },
      dataLabels: {
        enabled: false,
      },
      stroke: {
        width: 1,
        colors: ['#fff'],
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>Time to first success, cohort by cohort</h1>
        <p className="lead">
          Eight histograms over raw observations, binned on ONE shared set of
          edges and counted on one shared scale, so the whole distribution's
          slide to the left (newer cohorts finish faster) is the picture, not an
          artifact of per-panel binning.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="histogram"
              height={560}
            />
          </div>
        </div>

        <div className="note">
          Feed each panel its raw observations and the trellis derives one bin
          frame over the union sample, pushing an explicit
          <code>plotOptions.histogram.range</code> and <code>binWidth</code>{' '}
          into every panel: identical edges by construction, so the same bar
          always means the same interval. The y scale is shared over the bin
          <em>counts</em> (not the raw values, which live on a different axis
          entirely). Binning each panel to its own extent would put different
          intervals at the same x, which is the classic way a histogram grid
          lies. Trellis is a premium feature; without a license it renders with
          a trial watermark.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Distribution by Cohort in Angular

Using ApexCharts with Angular

This Distribution by Cohort example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (seed: any): any => {
        return function () {
          seed |= 0
          seed = (seed + 0x6d2b79f5) | 0
          var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
          t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
          return ((t ^ (t >>> 14)) >>> 0) / 4294967296
        }
      };

  private onboardingMinutes = (seed: any, mean: any, spread: any, n: any): any => {
        var rand = this.mulberry32(seed)
        var out = []
        for (var i = 0; i < n; i++) {
          var v = mean + (rand() + rand() + rand() - 1.5) * spread
          // A slow tail: some users always wander off mid-setup.
          if (rand() < 0.06) v += rand() * 25
          out.push(Math.max(2, Math.round(v * 10) / 10))
        }
        return out
      };

  private COHORTS: any = [
        { name: 'Jan', seed: 11, mean: 34, spread: 14 },
        { name: 'Feb', seed: 23, mean: 32, spread: 13 },
        { name: 'Mar', seed: 37, mean: 30, spread: 13 },
        { name: 'Apr', seed: 41, mean: 27, spread: 12 },
        { name: 'May', seed: 53, mean: 25, spread: 11 },
        { name: 'Jun', seed: 67, mean: 22, spread: 10 },
        { name: 'Jul', seed: 79, mean: 20, spread: 9 },
        { name: 'Aug', seed: 97, mean: 18, spread: 8 },
      ];

  private cohortSeries: any = this.COHORTS.map(function (c) {
        return {
          name: 'Onboarding time',
          cohort: c.name + ' cohort',
          data: this.onboardingMinutes(c.seed, c.mean, c.spread, 240),
        }
      });

  public chartOptions: Partial<ChartOptions> = {
          series: this.cohortSeries,
          chart: {
            id: 'cohortTrellis',
            type: 'histogram',
            height: 560,
            animations: {
              enabled: false,
            },
          },
          trellis: {
            by: 'cohort',
            columns: 4,
            gap: 12,
          },
          colors: ['#0E7490'],
          plotOptions: {
            histogram: {
              bins: 'auto',
            },
          },
          xaxis: {
            tickAmount: 5,
            labels: {
              rotate: 0,
              formatter: (val) => {
                return Math.round(Number(val)) + 'm'
              },
            },
          },
          dataLabels: {
            enabled: false,
          },
          stroke: {
            width: 1,
            colors: ['#fff'],
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Distribution by Cohort in Vue

Using ApexCharts with Vue

This Distribution by Cohort example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>Time to first success, cohort by cohort</h1>
      <p class="lead">
        Eight histograms over raw observations, binned on ONE shared set of
        edges and counted on one shared scale, so the whole distribution's slide
        to the left (newer cohorts finish faster) is the picture, not an
        artifact of per-panel binning.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="histogram"
            height="560"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <div class="note">
        Feed each panel its raw observations and the trellis derives one bin
        frame over the union sample, pushing an explicit
        <code>plotOptions.histogram.range</code> and <code>binWidth</code> into
        every panel: identical edges by construction, so the same bar always
        means the same interval. The y scale is shared over the bin
        <em>counts</em> (not the raw values, which live on a different axis
        entirely). Binning each panel to its own extent would put different
        intervals at the same x, which is the classic way a histogram grid lies.
        Trellis is a premium feature; without a license it renders with a trial
        watermark.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

import 'apexcharts/features/trellis'

// Eight monthly signup cohorts, ~240 raw onboarding times each. Every panel
// is a real histogram over its own observations, but the trellis derives ONE
// set of bin edges over the union sample and pushes it into every panel, so
// the same bar in every panel means the same interval and the drift of the
// whole distribution (newer cohorts finish faster) reads directly. Overlaid
// translucent histograms stop being readable past about three; eight panels
// with shared edges stay readable.
//
// Deterministic samples so the e2e snapshot is stable.
function mulberry32(seed) {
  return function () {
    seed |= 0
    seed = (seed + 0x6d2b79f5) | 0
    var t = Math.imul(seed ^ (seed >>> 15), 1 | seed)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}

// Bell-ish sample: mean minutes drop cohort by cohort, spread tightens.
function onboardingMinutes(seed, mean, spread, n) {
  var rand = mulberry32(seed)
  var out = []
  for (var i = 0; i < n; i++) {
    var v = mean + (rand() + rand() + rand() - 1.5) * spread
    // A slow tail: some users always wander off mid-setup.
    if (rand() < 0.06) v += rand() * 25
    out.push(Math.max(2, Math.round(v * 10) / 10))
  }
  return out
}

var COHORTS = [
  { name: 'Jan', seed: 11, mean: 34, spread: 14 },
  { name: 'Feb', seed: 23, mean: 32, spread: 13 },
  { name: 'Mar', seed: 37, mean: 30, spread: 13 },
  { name: 'Apr', seed: 41, mean: 27, spread: 12 },
  { name: 'May', seed: 53, mean: 25, spread: 11 },
  { name: 'Jun', seed: 67, mean: 22, spread: 10 },
  { name: 'Jul', seed: 79, mean: 20, spread: 9 },
  { name: 'Aug', seed: 97, mean: 18, spread: 8 },
]

var cohortSeries = COHORTS.map(function (c) {
  return {
    name: 'Onboarding time',
    cohort: c.name + ' cohort',
    data: onboardingMinutes(c.seed, c.mean, c.spread, 240),
  }
})

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: cohortSeries,
      chartOptions: {
        chart: {
          id: 'cohortTrellis',
          type: 'histogram',
          height: 560,
          animations: {
            enabled: false,
          },
        },
        trellis: {
          by: 'cohort',
          columns: 4,
          gap: 12,
        },
        colors: ['#0E7490'],
        plotOptions: {
          histogram: {
            bins: 'auto',
          },
        },
        xaxis: {
          tickAmount: 5,
          labels: {
            rotate: 0,
            formatter: function (val) {
              return Math.round(Number(val)) + 'm'
            },
          },
        },
        dataLabels: {
          enabled: false,
        },
        stroke: {
          width: 1,
          colors: ['#fff'],
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 1080px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
.lead {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 20px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  background: #f0fdfa;
  border-left: 3px solid #0e7490;
  padding: 12px 16px;
  font-size: 13px;
  color: #333;
  border-radius: 2px;
  line-height: 1.6;
  margin: 26px auto 0;
}
.note code {
  background: #ccfbf1;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>